From: Michael Fladischer <FladischerMichael@fladi.at>
Date: Sat, 20 Jul 2024 21:27:34 +0000
Subject: Use local objects.inv in default intersphinx configuration if files
 are present.

---
 docs/source/conf.py | 27 ++++++++++++++++++++++-----
 1 file changed, 22 insertions(+), 5 deletions(-)

diff --git a/docs/source/conf.py b/docs/source/conf.py
index 2347dec..f25ee51 100644
--- a/docs/source/conf.py
+++ b/docs/source/conf.py
@@ -1,5 +1,6 @@
 # Configuration file for the Sphinx documentation builder.
 
+import os
 import sys
 from pathlib import Path
 from datetime import date
@@ -29,10 +30,26 @@ extensions = [
     'sphinx.ext.intersphinx',
 ]
 
-intersphinx_mapping = {
-    'python': ('https://docs.python.org/3/', None),
-    'sphinx': ('https://www.sphinx-doc.org/en/master/', None),
-}
+def check_object_path(key, url, path):
+    if os.path.isfile(path):
+        return {key: (url, path)}
+    return {}
+
+intersphinx_mapping = {}
+intersphinx_mapping.update(
+    check_object_path(
+        'python',
+        f'https://docs.python.org/{sys.version_info.major}.{sys.version_info.minor}/',
+        f'/usr/share/doc/python{sys.version_info.major}.{sys.version_info.minor}/html/objects.inv'
+    )
+)
+intersphinx_mapping.update(
+    check_object_path(
+        'sphinx',
+        'https://www.sphinx-doc.org/en/master/',
+        '/usr/share/doc/sphinx-doc/html/objects.inv'
+    )
+)
 intersphinx_disabled_domains = ['std']
 
 templates_path = ['_templates']
@@ -42,4 +59,4 @@ templates_path = ['_templates']
 html_theme = 'sphinx_rtd_theme'
 
 # -- Options for EPUB output
-epub_show_urls = 'footnote'
\ No newline at end of file
+epub_show_urls = 'footnote'
